#include "AronTreeWidgetController.h"

#include "visitors/AronTreeWidgetConverter.h"

namespace armarx
{
    AronTreeWidgetController::AronTreeWidgetController(QTreeWidget* tree, QTreeWidgetItem* parent, const aron::type::ObjectPtr& type):
        parent(parent),
        tree(tree),
        type(type)
    {
        AronTreeWidgetCreatorVisitor v;
        aron::type::visit(v, type);

        if (v.createdQWidgetItem)
        {
            parent->addChild(v.createdQWidgetItem);
        }
    }

    aron::data::DictPtr AronTreeWidgetController::convertToAron() const
    {
        if (parent)
        {
            AronTreeWidgetConverterVisitor v(parent, 0);
            aron::type::visit(v, type);

            auto aron_args = aron::data::Dict::DynamicCastAndCheck(v.createdAron);
            return aron_args;
        }
        return nullptr;
    }

    void AronTreeWidgetController::setFromAron(const aron::data::DictPtr&)
    {

    }
}
