#pragma once

#include <RobotAPI/interface/armem/prediction.ice>
#include <RobotAPI/interface/armem/query.ice>

module armarx
{
  module armem
  {
    module server
    {
        interface PredictingMemoryInterface
        {
            /* Request multiple predictions from the memory.
             * The timestamp to requst a prediction for is encoded in the MemoryIDs.
             * The results are all packed into one QueryResult.
             */
            prediction::data::PredictionResultSeq
            predict(prediction::data::PredictionRequestSeq requests);

            /* Get the list of engines the memory offers for use in predictions.
             */
            prediction::data::PredictionEngineSeq getAvailableEngines();
        }
    };
  };
};
